#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include "uinput.h"
/* Globals */
static int uinp_fd = -1;
struct uinput_user_dev uinp;    // uInput device structure

/* Setup the uinput device */

int uinput_init (char *basedir, char *uinput)
{
  int i = 0;
  char dev[255] = "";

  sprintf (dev, "%s/%s", basedir, uinput);

  uinp_fd = open (dev, O_WRONLY | O_NDELAY);

  if (uinp_fd < 0)
    return 1;

  memset (&uinp, 0, sizeof (uinp));     // Intialize the uInput device to

  strncpy (uinp.name, "accessibility - kbd daemon", UINPUT_MAX_NAME_SIZE);
  uinp.id.version = 4;
  uinp.id.bustype = BUS_VIRTUAL;

  ioctl (uinp_fd, UI_SET_EVBIT, EV_KEY);
  ioctl (uinp_fd, UI_SET_EVBIT, EV_REL);

  for (i = 0; i < 256; i++)
   {
     ioctl (uinp_fd, UI_SET_KEYBIT, i);
   }

  /* Create input device into input sub-system */
  write (uinp_fd, &uinp, sizeof (uinp));

  if (ioctl (uinp_fd, UI_DEV_CREATE))
   {
     return 2;
   }

  return 0;
}

int uinput_key (struct input_event event)
{
  write (uinp_fd, &event, sizeof (event));
  return 0;
}

int uinput_close ()
{
  /* destroy the input device */
/*  ioctl (uinp_fd, UI_DEV_DESTROY);*/

  close (uinp_fd);
  return 0;
}
