/*
 *  suse-blinux - Braille-display support for linux
 *  Author: Marco Skambraks <marco@suse.de>
 *  SuSE GmbH Nuernberg
 *
 *
 * suse-blinux based on brltty
 * special thanks to the Brltty-Team
 * Nicolas Pitre <nico@cam.org>
 * Stphane Doyon <s.doyon@videotron.ca>
 * Nikhil Nair <nn201@cus.cam.ac.uk>
 *
 * This is free software, placed under the terms of the
 * GNU General Public License, as published by the Free Software
 * Foundation.  Please see the file COPYING for details.
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>
#include <string.h>

#define PATHLEN 200
char *getfgproc (char *sproc, int fgcon);

char *getfgproc (char *sproc, int fgcon)
{
  int i = 0;
  int pgrp = 0, tgid = 0;
  char str[100] = "", dev[50] = "";
  DIR *dirp;
  struct dirent *entry;
  int entvec[2000];

  dirp = opendir ("/proc");

  while ((entry = readdir (dirp)))
    if (atoi (entry->d_name))
     {
       entvec[i] = atoi (entry->d_name);
       i++;
     }

  closedir (dirp);

  sprintf (dev, "/dev/tty%i", fgcon);
  for (i -= 1; i > 1; i--)
   {
     char path[PATHLEN] = "";
     int cnt = 0;

     sprintf (path, "/proc/%i/fd/0", entvec[i]);
     cnt = readlink (path, str, 100);
     if (cnt < 0)
       str[0] = 0;
     else
       str[cnt] = 0;
     if (!strcmp (str, dev))
      {
	FILE *status;
	char name[100] = "";
	char stat_str[500] = "";
	char state_ch;
	int dummy_int = 0;

	sprintf (path, "/proc/%i/stat", entvec[i]);
	if ((status = fopen (path, "r")) == NULL)
	 {
	   strcpy (sproc, "default");
	   return sproc;
	 }

	if (NULL == fgets (stat_str, 250, status))
	  return strcpy (sproc, "default");

	if (!sscanf
	    (stat_str, "%d %s %c %d %d %d %d %d", &dummy_int, name, &state_ch,
	     &dummy_int, &tgid, &dummy_int, &dummy_int, &pgrp))
	  return strcpy (sproc, "default");
/*        printf("%s %c %d %d",name,state_ch,tgid,pgrp);*/
	fclose (status);
	if (state_ch != 'T' && tgid == pgrp)
	 {
	   strcpy (sproc, name + 1);
	   sproc[strlen (sproc) - 1] = 0;
	   return sproc;
	 }
      }
     str[0] = 0;
   }
  strcpy (sproc, "default");
  return sproc;			/* normaly unreached */
}
